/*
 * Copyright 2005, Mamezou Co.,LTD.
 */
package jp.co.thinkit.employee.dataaccess.springjdbc;

import jp.co.thinkit.employee.business.Employee;
import jp.co.thinkit.employee.business.EmployeeDao;

import org.springframework.jdbc.core.SqlParameter;
import org.springframework.jdbc.core.support.JdbcDaoSupport;
import org.springframework.jdbc.object.MappingSqlQuery;
import org.springframework.jdbc.object.SqlUpdate;

import java.sql.Types;

import java.util.List;


/**
 * ]ƈǗDAO
 * @author Mamezou
 * @version 1.0
 */
public class EmployeeDaoImpl extends JdbcDaoSupport implements EmployeeDao {
    // ]ƈp̃Iy[VNX
    private FindAllQuery findAllQuery = null;

    // ]ƈǉp̃Iy[VNX
    private AddEmployee addEmployee = null;

    // ]ƈ폜p̃Iy[VNX
    private RemoveEmployee removeEmployee = null;

    /**
     * Iy[VNX̏B
     */
    protected void initDao() throws Exception {
        this.findAllQuery = new FindAllQuery(getDataSource());
        this.addEmployee = new AddEmployee(getDataSource());
        this.removeEmployee = new RemoveEmployee(getDataSource());
    }

    /**
     * SĂ̏]ƈB
     * @return SĂ̏]ƈ
     */
    public List findAll() {
        return findAllQuery.execute();
    }

    /**
     * ]ƈǉāAVɑSĂ̏]ƈB
     * @param emp ]ƈNX
     * @return ǉ]ƈ
     */
    public int addEmployee(Employee emp) {
        return addEmployee.add(emp);
    }

    /**
     * ]ƈ폜āAVɑSĂ̏]ƈB
     * @param emp ]ƈNX
     * @return ǉ]ƈ
     */
    public int removeEmployee(Employee emp) {
        return removeEmployee.remove(emp);
    }

    /**
     * ]ƈp̃Iy[VNX
     */
    public static class FindAllQuery extends MappingSqlQuery {
        private static final String SQL = "SELECT id, name, address FROM EMPLOYEE";

        protected FindAllQuery(javax.sql.DataSource ds) {
            super(ds, SQL);
            compile();
        }

        protected Object mapRow(java.sql.ResultSet rs, int rownum)
            throws java.sql.SQLException {
            Employee emp = new Employee();
            emp.setId(rs.getInt("id"));
            emp.setName(rs.getString("name"));
            emp.setAddress(rs.getString("address"));

            return emp;
        }
    }

    /**
     * ]ƈǉp̃Iy[VNX
     */
    private static class AddEmployee extends SqlUpdate {
        private static final String SQL = "INSERT INTO EMPLOYEE VALUES(?, ?, ?)";

        protected AddEmployee(javax.sql.DataSource ds) {
            super(ds, SQL);
            declareParameter(new SqlParameter(Types.INTEGER));
            declareParameter(new SqlParameter(Types.VARCHAR));
            declareParameter(new SqlParameter(Types.VARCHAR));
            compile();
        }

        protected int add(jp.co.thinkit.employee.business.Employee emp) {
            Object[] params = new Object[] { null, emp.getName(), emp.getAddress() };

            return update(params);
        }
    }

    /**
     * ]ƈ폜p̃Iy[VNX
     */
    private static class RemoveEmployee extends SqlUpdate {
        private static final String SQL = "DELETE FROM EMPLOYEE WHERE ID = ?";

        protected RemoveEmployee(javax.sql.DataSource ds) {
            super(ds, SQL);
            declareParameter(new SqlParameter(Types.INTEGER));
            compile();
        }

        protected int remove(jp.co.thinkit.employee.business.Employee emp) {
            Object[] params = new Object[] { new Integer(emp.getId()) };

            return update(params);
        }
    }
}
